import pygame
import OpenGL
from OpenGL.GL import *

import game, image, text

over = True

class Main:
    def init(self):
        w, h = game.Game.size
        pygame.init()
        pygame.display.gl_set_attribute(pygame.GL_MULTISAMPLEBUFFERS, 1)
        pygame.display.gl_set_attribute(pygame.GL_MULTISAMPLESAMPLES, 1)
        pygame.display.set_caption("String")
        pygame.display.set_mode((w, h), pygame.OPENGL | pygame.DOUBLEBUF)
        
        glEnable(GL_TEXTURE_2D)
        glEnable(GL_BLEND)
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
        
        glEnable(GL_CULL_FACE)
        glCullFace(GL_BACK)
        
        glEnable(GL_LINE_SMOOTH)

        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()  
        glOrtho(-w / 2, w / 2, -h / 2, h / 2, -1000, 1000)
        glMatrixMode(GL_MODELVIEW)
        glLoadIdentity()

        glTranslatef(0, h / 2 + 32, 0)
        glRotatef(30, 1, 0, 0)
        glRotatef(-45, 0, 1, 0)

        glEnableClientState(GL_VERTEX_ARRAY)
        glEnableClientState(GL_NORMAL_ARRAY)
        
        glDisable(GL_TEXTURE_2D)
        
        glEnable(GL_DEPTH_TEST)
        glDepthFunc(GL_LESS)

        self.lighting()

        g = game.Game()
        game.game = g
    
    def lighting(self):
        glEnable(GL_LIGHTING)
        glEnable(GL_COLOR_MATERIAL)

        glMaterialfv(GL_FRONT, GL_AMBIENT, (0, 0, 0, 1));
        glMaterialfv(GL_FRONT, GL_DIFFUSE, (0, 0, 0, 1));
        glMaterialfv(GL_FRONT, GL_EMISSION, (0, 0, 0, 1));
        glMaterialfv(GL_FRONT, GL_SPECULAR, (1, 1, 1, 1));
        glMaterialf(GL_FRONT, GL_SHININESS, 1);

        glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE)

        glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE)
        glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE)

        glEnable(GL_LIGHT0)
        glLightfv(GL_LIGHT0, GL_AMBIENT, (0.2, 0.2, 0.2, 1));
        glLightfv(GL_LIGHT0, GL_SPECULAR, (0.1, 0.1, 0.1, 0));
        glLightfv(GL_LIGHT0, GL_DIFFUSE, (1, 1, 1, 1));
        glLightfv(GL_LIGHT0, GL_POSITION, (-1, 2, 1, 0));

def main():
    m = Main()
    m.init()
    game.game.init()
    game.game.run()
    over = False
    # force texture delete before OpenGL shuts down
    game.game = None
    image.Image.cache = None
    text.Text.cache = None

if __name__ == "__main__":
    main()
