from __future__ import division
import game
from math import *
from body import Body
from tile import Tile
from vector import Vector
from sprite import Sprite
import random

import OpenGL
from OpenGL.GL import *

class Shot(Sprite):
    def __init__(self, pos, mom):
        id = len(game.game.sprites)
        type = game.SHOT
        x, y, z = pos.xyz()
        Sprite.__init__(self, id, type, x / Tile.w, z / Tile.h, 0)
        self.position = pos
        game.game.sprites.append(self)
        self.alive = 60
        self.momentum = mom

    def update(self):
        self.position += self.momentum
        x, y, z = self.position
        
        c, h = self.map.tile_and_height_above_ground(x, z)
        if self.position.y < h:
            self.dead = True

        self.tx = int(x // Tile.w)
        self.tz = int(z // Tile.h)
        self.alive -= 1
        if self.alive < 0:
            self.dead = True

    def draw_3d(self):
        glPushMatrix()
        glMultMatrixf(self.matrix())
        game.game.meshes["Shot"].render()
        glPopMatrix()
    
    def draw_2d(self):
        x, y, z = self.position.xyz()
        pic = game.game.shot
        h = self.map.height_above_ground(x, z)
        glColor4f(0, 0, 0, 0.5)
        pic.draw_3d2(x, h + 4, z)
        glColor4f(1, 1, 1, 1)