from __future__ import division
import game
from math import *
from body import Body
from tile import Tile
from vector import Vector
from sprite import Sprite
import random

import OpenGL
from OpenGL.GL import *

class Spark(Sprite):
    def __init__(self, x, y, z):
        id = len(game.game.sprites)
        type = game.SPARK
        Sprite.__init__(self, id, type, x / Tile.w, z / Tile.h, 0)
        self.position = Vector(x, y, z)
        game.game.sprites.append(self)
        self.alive = 20
        self.momentum = Vector(random.random() - 0.5, random.random() * 0.5,
            random.random() - 0.5)

    def update(self):
        self.position += self.momentum
        self.alive -= 1
        if self.alive < 0:
            self.dead = True

    def draw_2d(self):
        x, y, z = self.position.xyz()
        pic = game.game.spark
        pic.draw_3d(x, y, z)
       