from vector import Vector

class Tile:
    w = 32 * 2 ** 0.5
    h = 32 * 2 ** 0.5
    d = 16 * 2 / 3 ** 0.5

    @staticmethod
    def blah(vs):
        ss = [
            (0, 2, 3, 1),
            (4, 5, 7, 6),
            (0, 4, 6, 2),
            (1, 3, 7, 5),
            (2, 6, 7, 3),
            (0, 1, 5, 4)]
        rv = []
        rn = []
        for s in ss:
            v1 = Vector(*vs[s[1]]) - Vector(*vs[s[0]])
            v2 = Vector(*vs[s[2]]) - Vector(*vs[s[1]])
            n = v1.cross(v2).normalize().xyz()

            for v in s:
                rv.append(vs[v])
                rn.append(n)
        return rv, rn

    @staticmethod
    def apply(vs, xt, yt, zt, xs, ys, zs):
        vs2 = []
        for x, y, z in vs:
            x *= xs
            y *= ys
            z *= zs
            x += xt
            y += yt
            z += zt
            vs2.append((x, y, z))
        return vs2

    @staticmethod
    def tile(xt, yt, zt, xs, ys, zs):
        vs = [(0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 1, 0),
            (0, 0, 1), (1, 0, 1), (0, 1, 1), (1, 1, 1),]
        return Tile.blah(Tile.apply(vs, xt, yt, zt, xs, ys,zs))

    @staticmethod
    def rampl(xt, yt, zt, xs, ys, zs):
        vs = [(0, 0, 0), (1, 0, 0), (0, 1, 0), (1, 1, 0),
            (0, -1, 1), (1, -1, 1), (0, 0, 1), (1, 0, 1),]
        return Tile.blah(Tile.apply(vs, xt, yt, zt, xs, ys,zs))
    
    @staticmethod
    def rampr(xt, yt, zt, xs, ys, zs):
        vs = [(0, 0, 0), (1, -1, 0), (0, 1, 0), (1, 0, 0),
            (0, 0, 1), (1, -1, 1), (0, 1, 1), (1, 0, 1),]
        return Tile.blah(Tile.apply(vs, xt, yt, zt, xs, ys,zs))
    
    @staticmethod
    def rope(start, end):
        vs = [start]
        vs += [start + Vector(3, 0, 0)]
        vs += [start + Vector(0, 0, 3)]
        vs += [end]
        vs += [end + Vector(3, 0, 0)]
        vs += [end + Vector(0, 0, 3)]
        ss = [(1, 2, 5, 4), (1, 4, 5, 2)]
        rv = []
        rn = []
        for s in ss:
            v1 = vs[s[1]] - vs[s[0]]
            v2 = vs[s[2]] - vs[s[1]]
            try:
                n = v1.cross(v2).normalize().xyz()
            except ZeroDivisionError:
                n = (0, 1, 0)

            for v in s:
                rv.append(vs[v].xyz())
                rn.append(n)
        return rv, rn

